<template>
  <div class="home col-8 mx-auto">
    <h2 class="text-center greeting indent">Personal cabinet</h2>

    <div id="success" class="alert alert-success" role="alert" v-if='updated'>
        <i class="icon fas fa-check">
            <span>Data was updated successfully</span>
        </i>
    </div>
    <div class="card card-primary card-outline">
        <div class="card-body box-profile">
            <ul class="list-group list-group-unbordered mb-3">
                <li class="list-group-item">
                    <div class="form-group row">
                        <label class="col-md-4 col-form-label" for="name">Name: </label>
                        <div class="col-md-8">
                            <input
                                type="text"
                                name="name"
                                id="name"
                                class="form-control"
                                :disabled="edit"
                                v-model="form.name"
                            />
                            <span class="text-danger" v-if="errors.name">
                                {{ errors.name[0] }}
                            </span>
                            <span id="nameHelp" class="text-danger" v-if="!check_name.name_valid">Name must
                                <span v-if="!check_name.name_required">be not empty.</span>
                                <span v-if="!check_name.name_min_length">has atleast 3 characters.</span>
                                <span v-if="!check_name.name_max_length">be shorter than 256 characters.</span>
                                <span v-if="!check_name.name_string">be a string.</span>
                                <span v-if="!check_name.name_special">hasn't a special characters.</span>
                            </span>
                        </div>
                    </div>
                </li>
                <li class="list-group-item" v-if="save">
                    <div class="form-group row">
                        <label class="col-md-4 col-form-label" for="new-password">New password: </label>
                        <div class="col-md-8">
                            <input
                                type="password"
                                name="password"
                                id="password"
                                class="form-control"
                                v-model="form.password"
                            />
                            <span class="text-danger" v-if="errors.password">
                                {{ errors.password[0] }}
                            </span>
                            <span id="passwordHelp" class="text-danger" v-if="!check_password.password_valid && check_password.password_confirmation">Password should contain
                                <span v-if="!check_password.password_minimum_length">atleast 6 characters.</span>
                                <span v-if="!check_password.password_number">one digit.</span>
                                <span v-if="!check_password.password_lowercase">one lowercase letter.</span>
                                <span v-if="!check_password.password_uppercase">one uppercase letter.</span>
                                <span v-if="!check_password.password_special">no one special character.</span>
                            </span>
                        </div>
                    </div>
                </li>
                <li class="list-group-item" v-if="save">
                    <div class="form-group row">
                        <label class="col-md-4 col-form-label" for="confirm-new-password">Confirm password: </label>
                        <div class="col-md-8">
                            <input
                                type="password"
                                name="password_confirmation"
                                id="password_confirmation"
                                class="form-control"
                                v-model="form.password_confirmation"
                            />
                            <span class="text-danger" v-if="errors.password_confirmation">
                                {{ errors.password_confirmation[0] }}
                            </span>
                            <span class="text-danger" v-if="!check_password.password_confirmation">
                                Password wasn't confirmed.
                            </span>
                        </div>
                    </div>
                </li>
                <li class="list-group-item" v-if="edit">
                    <div class="form-group row">
                        <label class="col-md-4 col-form-label" for="email">Email: </label>
                        <div class="col-md-8">
                            <input type="text" name="email" id="email" class="form-control" :value="userData('email')" disabled>
                        </div>
                    </div>
                </li>
                <li class="list-group-item" v-if="edit">
                    <div class="form-group row">
                        <label class="col-md-4 col-form-label" for="access-type">Access type: </label>
                        <div class="col-md-8">
                            <input type="text" name="access-type" id="access-type" class="form-control" :value="userData('access_type')" disabled>
                        </div>
                    </div>
                </li>
                <li class="list-group-item" v-if="checkUserAccess() && edit">
                    <div class="form-group row">
                        <label class="col-md-4 col-form-label" for="subscription-name">Subscription name: </label>
                        <div class="col-md-8">
                            <input type="text" name="end-access-period" id="subscription-name" class="form-control" :value="user.subscription_terms.name" disabled>
                        </div>
                    </div>
                </li>
                <li class="list-group-item" v-if="checkUserAccess() && edit">
                    <div class="form-group row">
                        <label class="col-md-4 col-form-label" for="end-access-period">End access period: </label>
                        <div class="col-md-8">
                            <input type="text" name="end-access-period" id="end-access-period" class="form-control" :value="userData('end_subscr_period')" disabled>
                        </div>
                    </div>
                </li>
            </ul>
            <div v-if='!checkUserAccess()'>
                You can
                <router-link
                    class="nav-link"
                    data-toggle="collapse"
                    :to="{ name: 'payment' }"
                    >
                    buy
                </router-link>
                subscription
            </div>
            <div v-if='checkUserAccess()'>
                You can
                <router-link
                    class="nav-link"
                    data-toggle="collapse"
                    :to="{ name: 'payment' }"
                    >
                    change
                </router-link>
                subscription plan
            </div>
        </div>
        <div class="card-footer box-profile" style="text-align: center;">
            <button
                type="submit"
                class="btn btn-primary"
                v-if="edit"
                @click.prevent='editToSave()'
                >
                Edit
            </button>
            <button
                type="submit"
                class="btn btn-primary"
                v-if="save"
                @click.prevent='saveUserData()'
                >
                Save
            </button>
            <button
                type="submit"
                class="btn btn-primary"
                v-if="save"
                @click.prevent='saveToEdit()'
                >
                Don't Save
            </button>
        </div>
    </div>

  </div>
</template>

<script>
import User from "../src/apis/User";
import eventHub from '../eventHub';
import shared from '../layouts/Shared';

//import { createNamespacedHelpers } from "vuex";
//const { mapGetters } = createNamespacedHelpers("user");

export default {
  props: ['user'],
  data() {
    return {
        form: shared.data.form,
        errors: [],
        updated: false,
        access: 'free',
        edit: true,
        save: false,
        check_name: shared.data.check_name,
        check_password: shared.data.check_password,
        response_status: null
    };
  },
  watch: {
      user: {
            handler: 'userNameToForm',
            immediate: true
        }
  },
  mounted() {
      /*this.$nextTick(() => {
          this.form.name = this.userData('name');
      });*/
  },
  computed: {
  },
    methods: {
      userData(dataProperty) {
          if (!this.user) {
              return null
          }

          return this.user[dataProperty];
      },
      checkUserAccess() {
          if (this.userData('access_type') == "subscribed") {
              return true;
          }
          return false;
      },
      userNameToForm() {
          this.form.id = this.userData('id');
          this.form.name = this.userData('name');
          //eventHub.$emit('auth-navbar');
      },
        editToSave() {
            this.edit = false;
            this.save = true;
        },
        saveToEdit() {
            this.edit = true;
            this.save = false;
        },
        saveUserData() {
            if (
                this.checkName() &&
                this.checkNotEmptyPassword()
            ) {
                User.update(this.form)
                .then((response) => {
                    localStorage.setItem("token", response.data.data.token);
                    eventHub.$emit('auth-navbar');
                    this.saveToEdit();
                    if (response.status == 200) {
                        this.updated = true;
                    }
                })
                .catch(error => {
                    if (error.response.status === 422) {
                        this.errors = error.response.data.errors;
                    }
                })
                .finally(() => {
                    this.showUpdated();
                });
            }
        },
        checkName: shared.methods.checkName,
        checkPassword: shared.methods.checkPassword,
        checkNotEmptyPassword() {
            if (this.form.password) {
                return this.checkPassword();
            }
            return true;
        },
        showUpdated() {
            setTimeout(function(scope) {
                scope.updated = false;
            }, 3000, this);
        }
    }
};
</script>

<style scoped>

.indent {
    margin-bottom: 30px;
}
.nav-link {
    color: crimson;
        display: inline-block;
}
.nav-link:hover{
    color: orange;
}

.card, .card-body, .list-group, .list-group-item {
    background-color: black;
    border-color: orange;
    color: orange;
}

.card {
    border: none;
}

</style>
